//http://c5.hakker.com
//inspired from linsniff

#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <ioctls.h>
#include <net/if.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <linux/if_ether.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

int resolv=0,log_intra=0,net_class=24,promisc=1,sock,promisc;
int got_device,got_logfile,got_masq_ip,logudp=1,logtcp=1,logicmp=1;
char masq_ip[18],intranet[18],tcplogfile[256],udplogfile[256],device[6];
char icmplogfile[256];
FILE *tcpfile,*udpfile,*icmpfile;

struct etherpacket{ 
 struct ethhdr eth;
 struct iphdr  ip;
 char buffert[2000];
} ep;

struct iphdr *ip;
struct tcphdr *tcp;
struct udphdr *udp;
struct icmphdr *icmp;

char *givetime(time_t *t){
 char *time;
 time=ctime(t);
 time[strlen(time)-6]=0;
 return time;
}

char *icmptype[]={
  "ECHOREPLY", "undef", "undef", "DEST_UNREACH", "SOURCE_QUENCH",
  "REDIRECT", "undef", "undef", "ECHO", "undef",
  "undef", "TIME_EXCEED", "PARAMETERPROB", "TIMESTAMP", "TIMESTAMPREPLY",
  "INFO_REQUEST", "INFO_REPLY", "ADDRESS", "ADDRESSREPLY"
};

char *icmpunreach[]={
"NET_UNREACH", "HOST_UNREACH", "PROT_UNREACH", "PORT_UNREACH", "FRAG_NEEDED",
  "SR_FAILED", "NET_UNKNOWN", "HOST_UNKNOWN", "HOST_ISOLATED", "NET_ANO",
"HOST_ANO", "NET_UNR_TOS", "HOST_UNR_TOS", "PKT_FILTERED", "PREC_VIOLATION",
  "PREC_CUTOFF"
};

char *icmpredirect[]={
  "REDIR_NET", "REDIR_HOST", "REDIR_NETTOS", "REDIR_HOSTTOS"
};

char *icmptime[]={
  "EXC_TTL", "EXC_FRAGTIME"
};


char *hostlookup(unsigned long int in,int fres){
 static char focus[1024];
 struct in_addr i;
 struct hostent *he;

 i.s_addr=in;
 if((fres)&&(resolv)){
  he=gethostbyaddr((char *)&i, sizeof(struct in_addr),AF_INET);
  if(he == NULL)
  strcpy(focus, inet_ntoa(i));
  else 
   strcpy(focus, he->h_name);
 } else 
  strcpy(focus, inet_ntoa(i));
 return focus;
}

void setup_interface(char *device){
 struct ifreq ifr;
 int s;

 sock=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sock<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sock, SIOCGIFFLAGS, &ifr))==-1){
  close(sock);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags |= IFF_PROMISC;
  if((s=ioctl(sock, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
}

void read_config(void){
char dump[300],type[20],intradump[20],secdump[270];
FILE *config;

 if((config=fopen("/etc/tgk-log","r"))==NULL){
  printf("Couldnt open config file\n");
  exit(1);
 }
 
 while(!feof(config)){
  memset(dump,0,sizeof(dump));
  memset(type,0,sizeof(type));
  memset(secdump,0,sizeof(secdump));
  fgets(dump,sizeof(dump)-1,config);

  if((dump[0]!='#')&&(dump[0]!=0)){
 
   strncpy(type,strtok(dump," "),sizeof(type)-1);
   if(strncasecmp(type,"resolv",strlen("resolv"))==0)
    if(strncasecmp(strtok(NULL," \n\t"),"on",strlen("on"))==0)
     resolv=1;

   if(strncasecmp(type,"log-tcp",strlen("log-tcp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logtcp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logtcp=0;
    else {
     printf("log-tcp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log-udp",strlen("log-udp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logudp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logudp=0;
    else {
     printf("log-udp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log-icmp",strlen("log-icmp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logicmp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logicmp=0;
    else {
     printf("log-udp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"tcplogfile",strlen("tcplogfile"))==0)
    strncpy(tcplogfile,strtok(NULL," \n\t"),sizeof(tcplogfile)-1);
   if(strncasecmp(type,"udplogfile",strlen("udplogfile"))==0)
    strncpy(udplogfile,strtok(NULL," \n\t"),sizeof(udplogfile)-1);
   if(strncasecmp(type,"icmplogfile",strlen("icmplogfile"))==0)
    strncpy(icmplogfile,strtok(NULL," \n\t"),sizeof(icmplogfile)-1);

   if(strncasecmp(type,"log_intranet",strlen("log_intranet"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     log_intra=1; 
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     log_intra=0;
    else {
     printf("log_intranet has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"net_class",strlen("net_class"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"16",strlen("16"))==0)
     net_class=16;
    else if(strncasecmp(secdump,"24",strlen("24"))==0)
     net_class=24;
    else {
     printf("net_class has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"intranet",strlen("intranet"))==0){
    strncpy(intradump,strtok(NULL," \n\t"),sizeof(intradump)-1);
    if(inet_addr(intradump)==-1){
     printf("Invalid intranet IP in config file\n");
     fclose(config);
     exit(1);
    } 
   }

   if(strncasecmp(type,"promisc",strlen("promisc"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     promisc=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     promisc=0;
    else {
     printf("promisc has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"masq_ip",strlen("masq_ip"))==0){
    strncpy(masq_ip,strtok(NULL," \n\t"),sizeof(masq_ip)-1);
    got_masq_ip=1;
    if(inet_addr(masq_ip)==-1){
     printf("Invalid masq_ip entry in config file\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"device",strlen("device"))==0){
    strncpy(device,strtok(NULL," \n\t"),sizeof(device)-1);
    if(strncmp(device,"eth",strlen("eth"))!=0){
     printf("Invalid network device entered?\n");
     printf("Should be eth<something>\n");
     fclose(config);
     exit(1);
    } else {
     got_device=1;
     setup_interface(device);
    }    
   }
  }
 }
 fclose(config);

 if((logtcp==1)&&(tcplogfile[0]==0)){
  printf("log-tcp has value ON but no tcplogfile was entered\n");
  exit(1);
 }
 else if((logtcp==1)&&(tcplogfile[0]!=0)){
  if((tcpfile=fopen(tcplogfile,"a"))==NULL){
   printf("Couldn't open tcp logfile %s\n",tcplogfile);
   exit(1);
  }
 }

 if((logudp==1)&&(udplogfile[0]==0)){
  printf("log-udp has value ON but no udplogfile was entered\n");
  exit(1);
 }
 else if((logudp==1)&&(udplogfile[0]!=0)){
  if((udpfile=fopen(udplogfile,"a"))==NULL){
   printf("Couldn't open udp logfile %s\n",udplogfile);
   exit(1);
  }
 }

 if((logicmp==1)&&(icmplogfile[0]==0)){
  printf("log-icmp has value ON but no udplogfile was entered\n");
  exit(1);
 }
 else if((logicmp==1)&&(icmplogfile[0]!=0)){
  if((icmpfile=fopen(icmplogfile,"a"))==NULL){
   printf("Couldn't open icmp logfile %s\n",icmplogfile);
   exit(1);
  }
 }

 if(got_device!=1){
  printf("You havent entered a network device in the config file\n");
  exit(1);
 }
 if(net_class==16){
  snprintf(intranet,sizeof(intranet)-1,"%s.",strtok(intradump,"."));
  strncat(intranet,strtok(NULL,"."),(sizeof(intranet)-1)-strlen(intranet));
  } else if(net_class==24){
   strncpy(intranet,intradump,strlen(intradump)-strlen(strrchr(intradump,'.')));
 }
}

int checkup(unsigned long sa, unsigned long da){
int value=1;

 if(!log_intra){
  if(strncmp(hostlookup(da,0),intranet,strlen(intranet))==0)
   value=0;
 } else {
  if((strncmp(hostlookup(sa,0),intranet,strlen(intranet))!=0)&&
    (strncmp(hostlookup(da,0),intranet,strlen(intranet))==0))
  value=0;
 }
 if(got_masq_ip){
  if(strncmp(hostlookup(sa,0),masq_ip,strlen(hostlookup(sa,0)))==0)
   value=0; 
 }
return(value);
}

void write_node(unsigned long sa, unsigned long da,unsigned short sp,unsigned short dp,unsigned int pt){
time_t ptime;

 if(checkup(sa,da)){
  if(pt==6){
   fprintf(tcpfile,"%s [%d] (",hostlookup(sa,1),ntohs(sp));
   fprintf(tcpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   fprintf(tcpfile,") => %s [%d] - ",hostlookup(da,1),ntohs(dp));
   fprintf(tcpfile,"%s\n",givetime(&ptime));
   fflush(tcpfile);
  } else if(pt==17){
   fprintf(udpfile,"%s [%d] (",hostlookup(sa,1),ntohs(sp));
   fprintf(udpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   fprintf(udpfile,") => %s [%d] - ",hostlookup(da,1),ntohs(dp));
   fprintf(udpfile,"%s\n",givetime(&ptime));
   fflush(udpfile);
  } else if(pt==1){
   fprintf(icmpfile,"%s (",hostlookup(sa,1));
   fprintf(icmpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   if((sp!=3)&&(sp!=5)&&(sp!=11))
    fprintf(icmpfile,") => %s [%s] - ",hostlookup(da,1),icmptype[sp]);
   else if(sp==3)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmpunreach[dp]); 
   else if(sp==5)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmpredirect[dp]);
   else if(sp==11)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmptime[dp]);
   fprintf(icmpfile,"%s\n",givetime(&ptime));
   fflush(icmpfile);
  }
 }
}

void cleanup(int sig){
struct ifreq ifr;
int s,sokka;

 if(sock)
  close(sock);
 if(logtcp)
  fclose(tcpfile);
 if(logudp)
  fclose(udpfile);
 if(logicmp)
  fclose(icmpfile);
 sokka=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sokka<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sokka, SIOCGIFFLAGS, &ifr))==-1){
  close(sokka);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags -= IFF_PROMISC ;
  if((s=ioctl(sokka, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
 close(sokka);
 exit(1);
}

void reread(int sig){
struct ifreq ifr;
int s,sokka;

 if(sock)
  close(sock);
 if(logtcp)
  fclose(tcpfile);
 if(logudp)
  fclose(udpfile);
 if(logicmp)
  fclose(icmpfile);

 sokka=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sokka<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sokka, SIOCGIFFLAGS, &ifr))==-1){
  close(sokka);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags -= IFF_PROMISC ;
  if((s=ioctl(sokka, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
 close(sokka);
 read_config();
}

void decide(void){
 if((ip->protocol==6)&&(logtcp==1)){	
  if(tcp->syn)
   write_node(ip->saddr,ip->daddr,tcp->source,tcp->dest,ip->protocol);
 }
 else if((ip->protocol==17)&&(logudp==1)){
  write_node(ip->saddr,ip->daddr,udp->source,udp->dest,ip->protocol);
 }
 else if((ip->protocol==1)&&(logicmp==1)){
  write_node(ip->saddr,ip->daddr,icmp->type,icmp->code,ip->protocol);
 }
}

int main(int argc, char *argv[]){
 int x,dn;	
 ip=(struct iphdr *)(((unsigned long)&ep.ip)-2);
 tcp=(struct tcphdr *)(((unsigned long)&ep.buffert)-2);
 udp=(struct udphdr *)(((unsigned long)&ep.buffert)-2);
 icmp=(struct icmphdr *)(((unsigned long)&ep.buffert)-2);
 read_config();

 if (fork()==0){
  close(0);close(1);close(2);
  setsid();
  chdir("/");
  umask(0);
  dn=open("/dev/null",O_RDWR);
  dup2(0,dn); dup2(1,dn); dup2(2,dn);
  close(dn);

  signal(SIGINT, cleanup);
  signal(SIGTERM, cleanup);
  signal(SIGKILL, cleanup);
  signal(SIGQUIT, cleanup);
  signal(SIGHUP, reread);
	
  while(1){
   x=read(sock, (struct etherpacket *)&ep, sizeof(struct etherpacket));
   if(x>1)
    decide();
  }
 }
return(0);
}
